// g_player.cpp

#include "g_local.h"

enum {
// running
axrun1, axrun2, axrun3, axrun4, axrun5, axrun6,
rockrun1, rockrun2, rockrun3, rockrun4, rockrun5, rockrun6,

// standing
stand1, stand2, stand3, stand4, stand5,
axstnd1, axstnd2, axstnd3, axstnd4, axstnd5, axstnd6,
axstnd7, axstnd8, axstnd9, axstnd10, axstnd11, axstnd12,

// pain
axpain1, axpain2, axpain3, axpain4, axpain5, axpain6,
pain1, pain2, pain3, pain4, pain5, pain6,

// death
axdeth1, axdeth2, axdeth3, axdeth4, axdeth5, axdeth6,
axdeth7, axdeth8, axdeth9,
deatha1, deatha2, deatha3, deatha4, deatha5, deatha6, deatha7,
deatha8, deatha9, deatha10, deatha11,
deathb1, deathb2, deathb3, deathb4, deathb5, deathb6, deathb7,
deathb8, deathb9,
deathc1, deathc2, deathc3, deathc4, deathc5, deathc6, deathc7, deathc8,
deathc9, deathc10, deathc11, deathc12, deathc13, deathc14, deathc15,
deathd1, deathd2, deathd3, deathd4, deathd5, deathd6, deathd7,
deathd8, deathd9,
deathe1, deathe2, deathe3, deathe4, deathe5, deathe6, deathe7,
deathe8, deathe9,

// attacks
nailatt1, nailatt2,
light1, light2,
rockatt1, rockatt2, rockatt3, rockatt4, rockatt5, rockatt6,
shotatt1, shotatt2, shotatt3, shotatt4, shotatt5, shotatt6,
axatt1, axatt2, axatt3, axatt4, axatt5, axatt6,
axattb1, axattb2, axattb3, axattb4, axattb5, axattb6,
axattc1, axattc2, axattc3, axattc4, axattc5, axattc6,
axattd1, axattd2, axattd3, axattd4, axattd5, axattd6,
};

#define FRAMETIME 0.1

#define ANIM(name, _frame, next, extra)		\
void next (Entity *self);					\
void name (Entity *self) {					\
	self->frame = (_frame);					\
	self->nextthink = g_time + FRAMETIME;	\
	self->think = next;						\
	extra;									\
}

void player_stand1 (Entity *self)
{
	self->frame = axstnd1;
	self->think = player_stand1;
	self->nextthink = g_time + FRAMETIME;

	self->weaponframe=0;
	if (self->velocity.x || self->velocity.y)
	{
		self->walkframe = 0;
		player_run (self);
		return;
	}

	if (self->weapon == IT_AXE)
	{
		if (self->walkframe >= 12)
			self->walkframe = 0;
		self->frame = axstnd1 + self->walkframe;
	}
	else
	{
		if (self->walkframe >= 5)
			self->walkframe = 0;
		self->frame = stand1 + self->walkframe;
	}
	self->walkframe = self->walkframe + 1;    
}

void player_run (Entity *self)
{
	self->frame = rockrun1;
	self->think = player_run;
	self->nextthink = g_time + FRAMETIME;

	self->weaponframe=0;
	if (!self->velocity.x && !self->velocity.y)
	{
		self->walkframe = 0;
		player_stand1 (self);
		return;
	}

	if (self->weapon == IT_AXE)
	{
		if (self->walkframe >= 6)
			self->walkframe = 0;
		self->frame = axrun1 + self->walkframe;
	}
	else
	{
		if (self->walkframe >= 6)
			self->walkframe = 0;
		self->frame = self->frame + self->walkframe;
	}
	self->walkframe = self->walkframe + 1;
}


void muzzleflash (Entity *self)
{
/*	WriteByte (MSG_MULTICAST, SVC_MUZZLEFLASH);
	WriteEntity (MSG_MULTICAST, self);
	multicast (self->origin, MULTICAST_PVS); */
}

void W_FireAxe (Entity *self);

ANIM( player_shot1, shotatt1, player_shot2, self->weaponframe=1; muzzleflash(self) )
ANIM( player_shot2, shotatt2, player_shot3, self->weaponframe=2 )
ANIM( player_shot3, shotatt3, player_shot4, self->weaponframe=3 )
ANIM( player_shot4, shotatt4, player_shot5, self->weaponframe=4 )
ANIM( player_shot5, shotatt5, player_shot6, self->weaponframe=5 )
ANIM( player_shot6, shotatt6, player_run,   self->weaponframe=6 )

ANIM( player_axe1, axatt1, player_axe2, self->weaponframe=1 )
ANIM( player_axe2, axatt2, player_axe3, self->weaponframe=2 )
ANIM( player_axe3, axatt3, player_axe4, self->weaponframe=3; W_FireAxe(self) )
ANIM( player_axe4, axatt4, player_run,  self->weaponframe=4 )

ANIM( player_axeb1, axattb1, player_axeb2, self->weaponframe=5 )
ANIM( player_axeb2, axattb2, player_axeb3, self->weaponframe=6 )
ANIM( player_axeb3, axattb3, player_axeb4, self->weaponframe=7; W_FireAxe(self) )
ANIM( player_axeb4, axattb4, player_run,   self->weaponframe=8 )

ANIM( player_axec1, axattc1, player_axec2, self->weaponframe=1 )
ANIM( player_axec2, axattc2, player_axec3, self->weaponframe=2 )
ANIM( player_axec3, axattc3, player_axec4, self->weaponframe=3; W_FireAxe(self) )
ANIM( player_axec4, axattc4, player_run,   self->weaponframe=4 )

ANIM( player_axed1, axattd1, player_axed2, self->weaponframe=5 )
ANIM( player_axed2, axattd2, player_axed3, self->weaponframe=6 )
ANIM( player_axed3, axattd3, player_axed4, self->weaponframe=7; W_FireAxe(self) )
ANIM( player_axed4, axattd4, player_run,   self->weaponframe=8 )


ANIM( player_rocket1, rockatt1, player_rocket2, self->weaponframe=1;muzzleflash(self) )
ANIM( player_rocket2, rockatt2, player_rocket3, self->weaponframe=2 )
ANIM( player_rocket3, rockatt3, player_rocket4, self->weaponframe=3 )
ANIM( player_rocket4, rockatt4, player_rocket5, self->weaponframe=4 )
ANIM( player_rocket5, rockatt5, player_rocket6, self->weaponframe=5 )
ANIM( player_rocket6, rockatt6, player_run,     self->weaponframe=6 )

//============================================================================
// lightning gun

void player_light1 (Entity *self);
void player_light2 (Entity *self);

void W_FireLightning (Entity *self);

void player_light1 (Entity *self)
{
	self->frame = light1;
	self->nextthink = g_time + FRAMETIME;
	self->think = player_light2;

	muzzleflash (self);

	if (!(self->buttons & BUTTON_ATTACK) /*|| intermission_running*/) {
		player_run (self);
		return;
	}

	self->weaponframe = self->weaponframe + 1;
	if (self->weaponframe == 5)
		self->weaponframe = 1;
//	SuperDamageSound ();
	W_FireLightning (self);
	self->attack_finished = g_time + 0.2;
}

void player_light2 (Entity *self)
{
	self->frame = light2;
	self->nextthink = g_time + FRAMETIME;
	self->think = player_light1;

	muzzleflash (self);

	if (!(self->buttons & BUTTON_ATTACK) /*|| intermission_running*/) {
		player_run (self);
		return;
	}

	self->weaponframe = self->weaponframe + 1;
	if (self->weaponframe == 5)
		self->weaponframe = 1;
//	SuperDamageSound();
	W_FireLightning (self);
	self->attack_finished = g_time + 0.2;
}

//====================================================================
// pain animation

void PainSound (Entity *self)
{
	if (self->health <= 0)
		return;

/*	if (damage_attacker.classname == "teledeath")
	{
		G_SoundEx (self, CHAN_VOICE, "player/teledth1.wav", 1, ATTN_NONE);
		return;
	}

// water pain sounds
	if (self->watertype == CONTENT_WATER && self->waterlevel == 3)
	{
		DeathBubbles(1);
		if (random() > 0.5)
			G_SoundEx (self, CHAN_VOICE, "player/drown1.wav", 1, ATTN_NORM);
		else
			G_SoundEx (self, CHAN_VOICE, "player/drown2.wav", 1, ATTN_NORM);
		return;
	}

// slime pain sounds
	if (self->watertype == CONTENT_SLIME)
	{
// FIX ME       put in some steam here
		if (random() > 0.5)
			sound (self, CHAN_VOICE, "player/lburn1.wav", 1, ATTN_NORM);
		else
			sound (self, CHAN_VOICE, "player/lburn2.wav", 1, ATTN_NORM);
		return;
	}

	if (self->watertype == CONTENT_LAVA)
	{
		if (random() > 0.5)
			sound (self, CHAN_VOICE, "player/lburn1.wav", 1, ATTN_NORM);
		else
			sound (self, CHAN_VOICE, "player/lburn2.wav", 1, ATTN_NORM);
		return;
	}
*/

	if (self->pain_finished > g_time)
	{
		self->axhitme = false;
		return;
	}
	self->pain_finished = g_time + 0.5;

	// don't make multiple pain sounds right after each other

	// axe pain sound
	if (self->axhitme)
	{
		self->axhitme = false;
		G_Sound (self, CHAN_VOICE, "player/axhit1.wav");
		return;
	}
	

	char *noise;

	switch (rand() % 6) {
		case 0: noise = "player/pain1.wav"; break;
		case 1: noise = "player/pain2.wav"; break;
		case 2: noise = "player/pain3.wav"; break;
		case 3: noise = "player/pain4.wav"; break;
		case 4: noise = "player/pain5.wav"; break;
		default: noise = "player/pain6.wav"; break;
	}

	G_Sound (self, CHAN_VOICE, noise);
}

ANIM( player_pain1, pain1, player_pain2, PainSound(self); self->weaponframe = 0 )
ANIM( player_pain2, pain2, player_pain3, ; )
ANIM( player_pain3, pain3, player_pain4, ; )
ANIM( player_pain4, pain4, player_pain5, ; )
ANIM( player_pain5, pain5, player_pain6, ; )
ANIM( player_pain6, pain6, player_run,   ; )

ANIM( player_axpain1, axpain1, player_axpain2, ; PainSound(self); self->weaponframe = 0 )
ANIM( player_axpain2, axpain2, player_axpain3, ; )
ANIM( player_axpain3, axpain3, player_axpain4, ; )
ANIM( player_axpain4, axpain4, player_axpain5, ; )
ANIM( player_axpain5, axpain5, player_axpain6, ; )
ANIM( player_axpain6, axpain6, player_run,     ; )

void player_pain (Entity *self, Entity *other)
{
	if (self->weaponframe)
		return;

//	if (self->invisible_finished > time)
//		return;         // eyes don't have pain frames

	if (self->weapon == IT_AXE)
		player_axpain1 (self);
	else
		player_pain1 (self);
}

//====================================================================
// death animation

// allow respawn after a certain time
void PlayerDead (Entity *self)
{
	self->nextthink = -1;
	self->deadflag = DEAD_DEAD;
}

ANIM( player_diea1, deatha1, player_diea2, ; )
ANIM( player_diea2, deatha2, player_diea3, ; )
ANIM( player_diea3, deatha3, player_diea4, ; )
ANIM( player_diea4, deatha4, player_diea5, ; )
ANIM( player_diea5, deatha5, player_diea6, ; )
ANIM( player_diea6, deatha6, player_diea7, ; )
ANIM( player_diea7, deatha7, player_diea8, ; )
ANIM( player_diea8, deatha8, player_diea9, ; )
ANIM( player_diea9, deatha9, player_diea10, ; )
ANIM( player_diea10, deatha10, player_diea11, ; )
ANIM( player_diea11, deatha11, player_diea11, PlayerDead(self) )


//====================================================================
// axe death frames

ANIM( player_die_ax1, axdeth1, player_die_ax2, ; )
ANIM( player_die_ax2, axdeth2, player_die_ax3, ; )
ANIM( player_die_ax3, axdeth3, player_die_ax4, ; )
ANIM( player_die_ax4, axdeth4, player_die_ax5, ; )
ANIM( player_die_ax5, axdeth5, player_die_ax6, ; )
ANIM( player_die_ax6, axdeth6, player_die_ax7, ; )
ANIM( player_die_ax7, axdeth7, player_die_ax8, ; )
ANIM( player_die_ax8, axdeth8, player_die_ax9, ; )
ANIM( player_die_ax9, axdeth9, player_die_ax9, PlayerDead(self) )
